﻿define(['lib/jquery-3.1.1.min', 'ej/ej.web.all.min'], function () {
    console.log("Loading Diagram...");

    // Defines a tool to interact with the user handle
    var CloneTool = (function (base) {
        ej.datavisualization.Diagram.extend(CloneTool, base);
        // Initializes the tool
        function CloneTool(name) {
            base.call(this, name);
            this.singleAction = true;
            this.clonedNodes = [];
            this.diffx = 0;
            this.diffy = 0;
            this.cursor = "pointer";
            this.check = false;
        }
        // Defines the required events
        CloneTool.prototype.mouseup = function (evt) {
            //clones the selected elements when the custom handle is clicked.
            this.diagram.copy();
            //Pastes the cloned elements.
            this.diagram.paste();
            base.prototype.mouseup.call(this, evt);
        };
        return CloneTool;
    })(ej.datavisualization.Diagram.ToolBase);

	
	

	//TODO: LinkTool
	
	
	
	
    var UserHandlePositions = ej.datavisualization.Diagram.UserHandlePositions;
    var userHandles = [];

    //cloneTool
    var cloneHandle = ej.datavisualization.Diagram.UserHandle();
    cloneHandle.name = "Clone";
	
    cloneHandle.position = UserHandlePositions.BottomLeft;
    cloneHandle.visible = true;
    cloneHandle.enableMultiSelection = true;
	
    cloneHandle.size = 30;
    cloneHandle.backgroundColor = "#4D4D4D";
    // cloneHandle.pathColor = "white";
    cloneHandle.pathData = "M4.6350084,4.8909971 L4.6350084,9.3649971 9.5480137,9.3649971 9.5480137,4.8909971 z M3.0000062,2.8189973 L11.184016,2.8189973 11.184016,10.999997 3.0000062,10.999997 z M0,0 L7.3649998,0 7.3649998,1.4020001 1.4029988,1.4020001 1.4029988,8.0660002 0,8.0660002 0,1.4020001 0,0.70300276 z";
   
    cloneHandle.tool = new CloneTool(cloneHandle.name);
    userHandles.push(cloneHandle);


    //LinkTool
    var linkHandle = ej.datavisualization.Diagram.UserHandle();
    linkHandle.name = "Line";

    linkHandle.position = ej.datavisualization.Diagram.UserHandlePositions.MiddleRight;
    linkHandle.visible = true;
	linkHandle.enableMultiSelection = false;
	
    linkHandle.size = 30;
    linkHandle.backgroundColor = "#4D4D4D";
    linkHandle.pathData = "M196.2104,93.6494L196.2104,90.2544L189.1674,90.2544L189.1674,87.6694L196.2104,87.6694L196.2104,84.7344L200.6674,89.1914z";

	//linkHandle.tool = new LinkTool(linkHandle.name);
    userHandles.push(linkHandle);



    $("#diagram").ejDiagram({
        nodes: nodes,
        connectors: connectors,
        enableContextMenu: true,

        defaultSettings: {
            connector: { segments: [{ "type": "orthogonal" }], labels: [{ "fontColor": "black" }], lineWidth: 2, targetDecorator: { shape: "arrow", width: "10", height: "10" } },
            node: { borderColor: "#000000", labels: [{ "fontColor": "black" }], ports: [{ offset: { x: 0, y: 0.5 }, name: "aport" }, { offset: { x: 0.5, y: 0 }, name: "bport" }, { offset: { x: 1, y: 0.5 }, name: "cport" }, { offset: { x: 0.5, y: 1 }, name: "dport" }] },
        },
        width: "100%",
        height: "100%",
        tool: ej.datavisualization.Diagram.Tool.SingleSelect | ej.datavisualization.Diagram.Tool.MultipleSelect,
        selectedItems: {
            userHandles: userHandles
        }
    });


});

var nodes = [];
var connectors = [];

nodes = [
    { name: "manufacturing", width: 175, height: 60, offsetX: 400, offsetY: 60, fillColor: "#05ADA4", labels: [{ "text": "Manufacturing Tablet PC" }], type: "basic", shape: "path", pathData: "M 269.711,29.3333C 269.711,44.061 257.772,56 243.044,56L 158.058,56C 143.33,56 131.391,44.061 131.391,29.3333L 131.391,29.3333C 131.391,14.6057 143.33,2.66669 158.058,2.66669L 243.044,2.66669C 257.772,2.66669 269.711,14.6057 269.711,29.3333 Z" },
    { name: "simProjection", width: 100, height: 80, offsetX: 400, offsetY: 175, fillColor: "#83A93F", labels: [{ "text": "Dual Sim \n Projection?" }], type: "basic", shape: "path", pathData: "M 253.005,115.687L 200.567,146.071L 148.097,115.687L 200.534,85.304L 253.005,115.687 Z" },
    { name: "manufacturingProcess", width: 100, height: 80, offsetX: 400, offsetY: 300, fillColor: "#33AACA", labels: [{ "text": "Processor \n Installation " }] },
    { name: "dualSim", width: 120, height: 60, offsetX: 600, offsetY: 175, fillColor: "#F1605A", labels: [{ "text": "Single Sim \n Projection \n Added" }], type: "basic", shape: "rectangle" },
    { name: "touch", width: 130, height: 120, offsetX: 400, offsetY: 445, fillColor: "#83A93F", labels: [{ "text": "Capacitive\n Touch?" }], type: "basic", shape: "path", pathData: "M 253.473,337.392L 200.551,390.313L 147.629,337.392L 200.551,284.47L 253.473,337.392 Z" },
    { name: "capacitiveTouch", width: 120, height: 60, offsetX: 200, offsetY: 445, fillColor: "#33AACA", labels: [{ "text": "Capacitive Touch \n Functionalities" }], type: "basic", shape: "rectangle" },
    { name: "resistiveTouch", width: 120, height: 60, offsetX: 600, offsetY: 445, fillColor: "#F1605A", labels: [{ "text": "Resistive Touch \n Functionalities" }], type: "basic", shape: "rectangle" },
    { name: "standards", width: 100, height: 80, offsetX: 400, offsetY: 575, fillColor: "#33AACA", labels: [{ "text": "Maintaining \n Standards" }], type: "basic", shape: "rectangle" },
    { name: "price", width: 100, height: 80, offsetX: 400, offsetY: 720, fillColor: "#33AACA", labels: [{ "text": "Fixing Price" }], type: "basic", shape: "rectangle" },
    { name: "selling", width: 135, height: 60, offsetX: 400, offsetY: 820, fillColor: "#05ADA4", labels: [{ "text": "Selling Process" }], type: "basic", shape: "path", pathData: "M 269.711,29.3333C 269.711,44.061 257.772,56 243.044,56L 158.058,56C 143.33,56 131.391,44.061 131.391,29.3333L 131.391,29.3333C 131.391,14.6057 143.33,2.66669 158.058,2.66669L 243.044,2.66669C 257.772,2.66669 269.711,14.6057 269.711,29.3333 Z" },
];


connectors = [
    {
        name: "connector1", sourceNode: "manufacturing", targetNode: "simProjection", sourcePort: "dport", targetPort: "bport"
    },
    { name: "connector2", sourceNode: "simProjection", targetNode: "manufacturingProcess", sourcePort: "dport", targetPort: "bport", labels: [{ "text": "Yes", "fontColor": "black", "fillColor": "white" }] },
    { name: "connector3", sourceNode: "simProjection", targetNode: "dualSim", sourcePort: "cport", targetPort: "aport", labels: [{ "text": "No", "fontColor": "black", "fillColor": "white" }] },
    { name: "connector4", sourceNode: "dualSim", targetNode: "manufacturingProcess", sourcePort: "dport", targetPort: "cport" },
    { name: "connector5", sourceNode: "manufacturingProcess", targetNode: "touch", sourcePort: "dport", targetPort: "bport" },
    { name: "connector6", sourceNode: "touch", targetNode: "capacitiveTouch", sourcePort: "aport", targetPort: "cport", labels: [{ "text": "Yes", "fontColor": "black", "fillColor": "white" }] },
    { name: "connector7", sourceNode: "touch", targetNode: "resistiveTouch", sourcePort: "cport", targetPort: "aport", labels: [{ "text": "No", "fontColor": "black", "fillColor": "white" }] },
    { name: "connector8", sourceNode: "capacitiveTouch", targetNode: "standards", sourcePort: "dport", targetPort: "aport" },
    { name: "connector9", sourceNode: "resistiveTouch", targetNode: "standards", sourcePort: "dport", targetPort: "cport" },
    { name: "connector10", sourceNode: "standards", targetNode: "price", sourcePort: "dport", targetPort: "bport" },
    { name: "connector11", sourceNode: "price", targetNode: "selling", sourcePort: "dport", targetPort: "bport" },
];
